extern malloc
extern free

global templosClasicos
global cuantosTemplosClasicos

;########### SECCION DE TEXTO (PROGRAMA)
section .text

%define offset_largo 0
%define offset_nombre 8
%define offset_corto 16
%define size_templo 24

;rdi = templo *temploArr, rsi = size_t temploArr_len
templosClasicos:
    push rbp
    mov rbp, rsp

    push r12 ; r12 = M
    push r13 ; r13 = N
    push r14 ; r14 = temploArr_len
    push r15 ; r15 = templo *temploArr y alinea

    mov r15, rdi

    xor r9, r9 ; r9 = 0 y lo uso como puntero a nuevo array
    xor rax, rax ; rax = 0 y lo uso como puntero a nuevo array y resultado final

    mov r14, rsi
    ;rdi y rsi ya tienen lo que necesito para calcular cant de clasicos
    call cuantosTemplosClasicos

    mov rdi, rax ; rdi = cantTemplosClasicos
    imul rdi, size_templo ; rdi = cantTemplosClasicos * size_templo

    ; pido la memoria para el nuevo array
    call malloc
    ; guardo puntero a nuevo array en r9
    mov r9, rax

    xor rcx, rcx ; rcx = 0 y lo uso como contador de ciclo

    .loop:
    ; limpio r12, r13 y r8
    xor r12, r12 
    xor r13, r13
    xor r8, r8 ; lo uso para guardar el puntero a nombre

    ; si rcx = temploArr_len termina el programa
    cmp rcx, r14
    je .fin

    mov BYTE r12b, [r15 + offset_largo] ; cargo M
    mov BYTE r13b, [r15 + offset_corto] ; cargo N
    mov r8, [r15 + offset_nombre] ; cargo nombre

    shl r13, 1 ; shift izq 1 posicion = multiplico por 2
    inc r13

    ; en este punto r13b = 2*N + 1
    ; si r12b = r13b, agrego templo a nuevos
    cmp BYTE r12, r13
    jne .seguir
    mov [r9 + offset_largo], r12
    ;vuelvo a N original
    dec r13
    shr r13, 1 
    mov [r9 + offset_corto], r13
    mov [r9 + offset_nombre], r8
    add r9, size_templo

    .seguir:
    inc rcx
    add r15, size_templo
    jmp .loop

    .fin:
    pop r15
    pop r14
    pop r13
    pop r12
    pop rbp
    ret


;rdi = templo *temploArr, rsi = size_t temploArr_len
cuantosTemplosClasicos:
    push rbp
    mov rbp, rsp

    push r12 ; r12 = M
    push r13 ; r13 = N y alinea pila

    xor rax, rax ; rax = 0 y lo uso como contador de retorno
    xor rcx, rcx ; rcx = 0 y lo uso como contador de ciclo

    .loop:
    ; limpio r12 y r13
    xor r12, r12 
    xor r13, r13

    ; si rcx = rsi termina el programa
    cmp rcx, rsi
    je .fin

    mov BYTE r12b, [rdi + offset_largo] ; cargo M
    mov BYTE r13b, [rdi + offset_corto] ; cargo N

    shl r13, 1 ; shift izq 1 posicion = multiplico por 2
    inc r13

    ; en este punto r13b = 2*N + 1
    ; si r12b = r13b, incremento rax y sigo, sino solo sigo
    cmp BYTE r12, r13
    jne .seguir
    inc rax

    .seguir:
    inc rcx
    add rdi, size_templo
    jmp .loop


    .fin:
    pop r13
    pop r12
    pop rbp
    ret


