section .rodata
azules: dd 0xFFFFFFFF, 0x00000000, 0x00000000, 0x00000000
verdes: dd 0x00000000, 0xFFFFFFFF, 0x00000000, 0x00000000
rojos: dd 0x00000000, 0x00000000, 0xFFFFFFFF, 0x00000000
alphas: dd 0x00000000, 0x00000000, 0x00000000, 0xFFFFFFFF
pixel_1: db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x03, 0x02, 0x01, 0x00
pixel_2: db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x07, 0x06, 0x05, 0x04
pixel_3: db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x08, 0x07, 0x06, 0x05
pixel_4: db 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x0C, 0x0B, 0x0A, 0x09
coeficientes_grises: dd 0.114, 0.587, 0.299, 0.0

global miraQueCoincidencia

;########### SECCION DE TEXTO (PROGRAMA)
section .text
    %define blue 0
	%define green 1
	%define red 2
	%define alpha 3
	%define pixel_size 4
	%define offset_pixels 16

;uint8_t *A = rdi, uint8_t *B = rsi, uint32_t N = rdx,  uint8_t *laCoincidencia = rcx
miraQueCoincidencia:
    push rbp
    mov rbp, rsp

    push rbx ; guardo pixeles recorridos
    xor rbx, rbx
    push r12 ; alinea pila

    movdqu xmm14, [coeficientes_grises]

    ;cantidad de pixeles = N*N
    imul rdx, rdx
    imul rdx, 4 ; 4 bytes por pixel

    movdqu xmm7, [azules]

    .ciclo:
    ; si fila actual = N terminar
    cmp rbx, rdx
    je .fin

    ; en cada xmm entran 4 bytes, se cargan los bytes de A en xmm0, B en xmm1
    movdqu xmm0, [rdi] ;en xmm0 me quedo el original, en xmm1 hago las comparaciones
    movdqu xmm1, [rdi]
    movdqu xmm2, [rsi]

    pcmpeqd xmm1, xmm2 ; comparo los pixeles
    ;en este punto en xmm1 va a haber 1 en los double words (pixels) iguales

    ; xmm3 = pixel 1, xmm4 = pixel 2, xmm5 = pixel 3, xmm6 = pixel 4

    ;en xmm3 se guarda el primer pixel con extencion a 0s
    movdqu xmm13, [pixel_1]
    movdqu xmm3, xmm0
    pshufb xmm3, xmm13
    pmovzxbd xmm3, xmm3 ;extiendo a toda la xmm
    cvtdq2ps xmm3, xmm3 ; convierto a float

    ;sigo trayendo pixeles para operar
    movdqu xmm13, [pixel_2]
    movdqu xmm4, xmm0
    pshufb xmm4, xmm13
    pmovzxbd xmm4, xmm4 ;extiendo a toda la xmm
    cvtdq2ps xmm4, xmm4

    movdqu xmm13, [pixel_3]
    movdqu xmm5, xmm0
    pshufb xmm5, xmm13
    pmovzxbd xmm5, xmm5 ;extiendo a toda la xmm
    cvtdq2ps xmm5, xmm5

    movdqu xmm13, [pixel_4]
    movdqu xmm6, xmm0
    pshufb xmm6, xmm13
    pmovzxbd xmm6, xmm6 ;extiendo a toda la xmm
    cvtdq2ps xmm6, xmm6

    ; en escala de grises
    mulps xmm3, xmm14
    mulps xmm4, xmm14
    mulps xmm5, xmm14
    mulps xmm6, xmm14

    haddps xmm3, xmm3
    haddps xmm3, xmm3
    haddps xmm4, xmm4
    haddps xmm4, xmm4
    haddps xmm5, xmm5
    haddps xmm5, xmm5
    haddps xmm6, xmm6
    haddps xmm6, xmm6
    ; dejo en los 4 bytes mas bajos el pixel en escala de grises

    ; vuelvo a int
    cvttps2dq xmm3, xmm3
    cvttps2dq xmm4, xmm4
    cvttps2dq xmm5, xmm5
    cvttps2dq xmm6, xmm6

    ;desempaquetado
    packssdw xmm3, xmm3
    packuswb xmm3, xmm3 
    packssdw xmm4, xmm4
    packuswb xmm4, xmm4 
    packssdw xmm5, xmm5
    packuswb xmm5, xmm5 
    packssdw xmm6, xmm6
    packuswb xmm6, xmm6 

    pextrd r12d, xmm3, 0
    mov DWORD [rcx], r12d
 
    pextrd r12d, xmm4, 0
    mov DWORD [rcx+4], r12d

    pextrd r12d, xmm5, 0
    mov DWORD [rcx+8], r12d

    pextrd r12d, xmm6, 0
    mov DWORD [rcx+12], r12d

    ;avanzo 4 pixeles de lectura en A y B
    add rdi, offset_pixels
    add rsi, offset_pixels

    ;avanzo contador de desplazamiento
    add rbx, offset_pixels

    ;avanzo pixeles de extritura
    add rcx, 16

    jmp .ciclo

    .fin:
    pop r12
    pop rbx
    pop rbp
    ret


